package eu.ruekov.ruakij.LinkedBeaconTeleporters.linkedBeaconTeleporter;

import eu.ruekov.ruakij.LinkedBeaconTeleporters.Function;
import eu.ruekov.ruakij.LinkedBeaconTeleporters.Main;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.event.block.BlockBreakEvent;

import java.util.List;

public class LinkedBeaconTeleporterBlock extends LinkedBeaconTeleporter {
    // FIXME: Storing the block like this will block the world from unloading and might be dangerous
    Block block;

    public LinkedBeaconTeleporterBlock(String teleporterId, Block block) {
        super(teleporterId);

        this.block = block;
    }

    public Block block(){
        return block;
    }


    public LinkedBeaconTeleporterItem break_(BlockBreakEvent e){
        Location loc = this.block().getLocation();

        // Dont drop anything
        e.setDropItems(false);
        e.setExpToDrop(0);

        // Notify Player when link was destroyed
        if(this.linkedBeaconTeleporters.size() == 2){
            e.getPlayer().sendMessage("§cConnection to Teleporter with id §7"+ this.teleporterId +" §e("+
                    (int)((LinkedBeaconTeleporterBlock)this.linkedBeaconTeleporters.get(0)).block.getLocation().distance(
                            ((LinkedBeaconTeleporterBlock)this.linkedBeaconTeleporters.get(1)).block().getLocation()
                    )
                    +" Blocks away) §cdestroyed");
        }

        // Remove from list
        this.linkedBeaconTeleporters.remove(this);

        if(this.linkedBeaconTeleporters.size() == 0){
            // List empty, delete from placedLBTsById
            LinkedBeaconTeleporterManager.placedLBTsById.remove(
                    this.teleporterId
            );
        }

        // Remove from loc
        LinkedBeaconTeleporterManager.placedLBTByLoc.remove(
                Function.serialiseBlockLocation(loc)
        );

        // Item from block
        LinkedBeaconTeleporterItem lbtItem = new LinkedBeaconTeleporterItem(this.teleporterId());

        // Drop custom-item
        if(e.getPlayer().getGameMode() != GameMode.CREATIVE)
            loc.getWorld().dropItemNaturally(
                    loc.add(0.5, 0, 0.5),
                    lbtItem.item()
            );

        return lbtItem;
    }


    // Conversion methods
    public static LinkedBeaconTeleporterBlock getFromLocation(Location loc){
        return LinkedBeaconTeleporterManager.getLbtBlockFromLocation(loc);
    }
    public static List<LinkedBeaconTeleporter> getListFromTeleportId(String teleportId){
        return LinkedBeaconTeleporterManager.getLbtBlocksFromTeleportId(teleportId);
    }
}
